#ifndef __POLYRAWEXPORTER_H
#define __POLYRAWEXPORTER_H

//polyRawExporter.h
//
// *****************************************************************************
//
// Copyright (C) 1997-2002 Alias|Wavefront, a division of Silicon Graphics Limited.
// 
// The information in this file is provided for the exclusive use of the
// licensees of Alias|Wavefront.  Such users have the right to use, modify,
// and incorporate this code into other products for purposes authorized
// by the Alias|Wavefront license agreement, without fee.
// 
// ALIAS|WAVEFRONT DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
// INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
// EVENT SHALL ALIAS|WAVEFRONT BE LIABLE FOR ANY SPECIAL, INDIRECT OR
// CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
// DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
// TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
// PERFORMANCE OF THIS SOFTWARE.
//
// *****************************************************************************
//
// CLASS:    polyRawExporter
//
// *****************************************************************************
//
// CLASS DESCRIPTION (polyRawExporter)
// 
// polyRawExporter is a class derived from polyExporter.  It allows the export
// of polygonal mesh data in raw text format.  The file extension for this type
// is ".raw".
//
// *****************************************************************************

//DEL #include "polyExporter.h"
#include <maya/MPxFileTranslator.h>

#include <iostream.h>
#include <fstream.h>


//class polyWriter;
class MDagPath;
class MFnDagNode;

class polyRawExporter:public MPxFileTranslator {

	public:
				polyRawExporter(){}
	    virtual		~polyRawExporter();
	    static  void*	creator();
	    MString		defaultExtension () const;
	    MStatus		initializePlugin(MObject obj);
	    MStatus		uninitializePlugin(MObject obj);

	    virtual MStatus	writer (const MFileObject& file,
							const MString& optionsString,
							MPxFileTranslator::FileAccessMode mode);
	    virtual bool	haveWriteMethod () const;
	    virtual bool	haveReadMethod () const;
	    virtual bool	canBeOpened () const;
	    void		doTabs(ostream& os);
	    int			tabs;
	    ofstream		os2;

	protected:	
		virtual	bool			isVisible(MFnDagNode& fnDag, MStatus& status);
		virtual	MStatus			exportAll(ostream& os);
		virtual	MStatus			exportSelection(ostream& os);
			void			writeHeader(ostream& os);
		virtual void			writeFooter(ostream& os);
		virtual MStatus			processPolyMesh(const MDagPath dagPath, ostream& os);
		//virtual polyWriter*		createPolyWriter(const MDagPath dagPath, MStatus& status) = 0;
		polyRawWriter*		createPolyWriter(const MDagPath dagPath, MStatus& status);
		//void		writeHeader(ostream& os);



};


#endif /*__POLYEXPORTER_H*/
